﻿package MT::Plugin::RequestCache;
use strict;
use MT;
use MT::Plugin;
use MT::Request;

our $VERSION = '0.1';

use base qw( MT::Plugin );

@MT::Plugin::RequestCache::ISA = qw( MT::Plugin );

my $plugin = new MT::Plugin::RequestCache ( {
    name => 'RequestCache',
    id =>   'RequestCache',
    key =>  'requestcache',
    description => 'Use built cache in single request.',
    author_name => 'Junnama Noda',
    author_link => 'http://junnama.alfasado.net/online/',
    'version' => $VERSION,
} );

MT->add_plugin( $plugin );

sub init_registry {
    my $plugin = shift;
    $plugin->registry ( {
        tags => {
            block => {
                'RequestCacheBlock' => \&_hndlr_request_cache,
            },
        }
   } );
}

# <MTRequestCacheBlock id="RecentEntries" blog_id="$blog_id">
#     Some template tags here.
# </MTRequestCacheBlock>

sub _hndlr_request_cache {
    my ( $ctx, $args, $cond ) = @_;
    my $id = $args->{ id };
    my $blog_id = $args->{ blog_id };
    $id = "request_cache_$id";
    $id .= '_' . $blog_id if $blog_id;
    my $r = MT::Request->instance;
    my $cache = $r->cache( $id );
    return $cache if $cache;
    my $tokens = $ctx->stash( 'tokens' );
    my $builder = $ctx->stash( 'builder' );
    my $res = $builder->build( $ctx, $tokens, $cond );
    $r->cache( $id, $res );
    return $res;
}

1;